//import waba.fx.*;
//import waba.io.*;
//import waba.sys.*;    // Convert
import waba.ui.*;
import waba.util.*;   // Vector
import extra.ui.*;    // !!!b. wextra: Title, List

// Random, StringUtil

/**
 * @author <A HREF="mailto:weyer@kagi.com">Steve Weyer</A>
 * Copyright (c) 2001, S. Weyer. All right reserved.
 * @version waba 1.0
 * !!!e ?? Mar 2001 tab
 * !!!d 05 Mar 2001 adds 1 to range ("9" was never generated)
 * !!!c 08 Feb 2001 numDigitChoice init w/o Vector
 * !!!b 13 Jan 2001: uses wextra. removed old code; Result button
 * !!!a 25 Nov 2000: port from JS/Newton
 * <A HREF="http://www.kagi.com/weyer/#PFB">Steve's other PFB versions</A>
 * <A HREF="http://www.kagi.com/weyer/#Waba">Steve's other Waba apps</A>
 *
 * ! Newton class heap: 22000
 * ?? give incremental feedback (on each character guess)
 * ?? font metrics for Palm, WinCE?
 * ?? setFocus doesn't giveup earlier focus
**/

public class PFB extends MainWindow {
  private static final boolean DEBUG = false;
  private static final int NUMDIGIT_MIN = 2;
  private static final int NUMDIGIT_MAX = 5;
  private static final String DIGITS = "0123456789";

  private static final int COMPHT  = 15;
  private static final int COMPWID = 40;
  private static final int COMPSEP = 2;

  private static final String[] CMDSTR = { // no more than numGuesses
    "PFB",    "by weyer@kagi.com",
    "Zero",   "is zero a possible digit?",
    "#",      "number of digits: " + NUMDIGIT_MIN + "-" + NUMDIGIT_MAX,
    "Result", "button, or <tab> or <enter> key",
    "Fermi",  "correct digit placed correctly",
    "Pico",   "correct digit placed incorrectly",
    "Bagels", "no digits are correct",
  };

  private static final String[] EXSTR = {
    "Zero:",  "checked",
    "#:",     "3",
    "376",    "Bagels",
    "914",    "Pico",
    "820",    "Fermi Pico",
    "092",    "Fermi Pico Pico",
    "029",    "Fermi Fermi Fermi!",
  };

  private Button newGameButton;
  private Check allowZeroCheck;
  private List numDigitChoice;  // !!!b. Edit
  private Button giveupButton;
  private Button helpButton;
  private Button exampleButton;
  private Label guessLabel;
  private Vector guesses; // Edit
  //private Label resultLabel;
  private Button resultButton;
  private Vector results; // Label

  private Random rand;
  private String answer;

  private int numGuesses  = 7; // calc dynamically based on screen height
  private boolean allowZero = true;
  private int numDigits = 3;

  public PFB() {
    int i, objY = 0, objX, objWid;
    Edit tf;
    Label lbl;

    numGuesses = ((this.height-COMPSEP) / COMPHT) - 3;
    if (DEBUG) System.out.println("numGuesses: " + numGuesses);

    // TOP ROW: title, allowZeroCheck, numDigitChoice
    Title title = new Title("Pico Fermi Bagels");
    title.setRect(0, objY, this.width, COMPHT);
    add(title);

    objWid = (this.width <= 160) ? 28 : 40; // for numDigitChoice
    objX = this.width - (COMPWID + objWid);
    allowZeroCheck = new Check("Zero");
    allowZeroCheck.setChecked(allowZero);
    allowZeroCheck.setRect(objX, objY, COMPWID, COMPHT-1);
    add(allowZeroCheck);

    lbl = new Label("#:");
    lbl.setRect(this.width - objWid, objY, 10, COMPHT-1);
    add(lbl);
    objWid = objWid - 10 - COMPSEP;

    //numDigitChoice = new Edit(); !!!b
    numDigitChoice = new List();
    for (i = NUMDIGIT_MIN; i <= NUMDIGIT_MAX; i++)
      numDigitChoice.add(String.valueOf(i));

    //numDigitChoice.setText(String.valueOf(numDigits));
    numDigitChoice.setSelectedIndex(numDigits - NUMDIGIT_MIN);

    //numDigitChoice.setRect(this.width - objWid, objY, objWid, COMPHT-2);
    numDigitChoice.setRect(this.width - objWid, objY, objWid, COMPHT+1);
    add(numDigitChoice);

    // BOTTOM ROW: Start, Help, Ex., GiveUp
    objY = this.height - COMPHT;
    objX = 0;
    objWid = COMPWID - 11;
    newGameButton = new Button("Start");
    newGameButton.setRect(objX, objY, objWid, COMPHT);
    add(newGameButton);

    objX += objWid + COMPSEP;
    objWid = COMPWID - 12;
    helpButton = new Button("Help");
    helpButton.setRect(objX, objY, objWid, COMPHT);
    add(helpButton);

    objX += objWid + COMPSEP;
    objWid = COMPWID - 15;
    exampleButton = new Button("Ex.");
    exampleButton.setRect(objX, objY, objWid, COMPHT);
    add(exampleButton);

    objX += objWid + COMPSEP;
    objWid = COMPWID;
    giveupButton = new Button("Give Up");
    giveupButton.setRect(objX, objY, objWid, COMPHT);
    add(giveupButton);

    // HEADING (2nd) row: Guess, Result
    objX = COMPWID - 10;
    objWid = this.width - (objX + COMPSEP*2);
    objY = COMPHT + COMPSEP;
    guessLabel = new Label("Guess");
    guessLabel.setRect(0, objY, objX, COMPHT);
    add(guessLabel);

    //resultLabel = new Label("Result");
    //resultLabel.setRect(objX + COMPSEP*2, objY, objWid, COMPHT);
    //add(resultLabel);
    resultButton = new Button("Result");
    resultButton.setRect(objX + COMPSEP*2, objY, COMPWID, COMPHT);
    add(resultButton);

    // MIDDLE ROWS: Guess, Result
    guesses = new Vector(numGuesses);  // Edit
    results = new Vector(numGuesses);  // Label
    for (i = 0; i < numGuesses; i++) {
      objY += COMPHT;
      tf = new Edit();
      tf.setRect(0,objY, objX, COMPHT);
      guesses.add(tf);
      add(tf);

      lbl = new Label("");
      lbl.setRect(objX + COMPSEP*2, objY+1, objWid, COMPHT); // line up Edit & Label
      results.add(lbl);
      add(lbl);
    };

    rand = new Random();
    newGame();
  }

  public void onEvent(Event ev) {
    Object obj = ev.target;
    int evType = ev.type, pos, slen;
    String str;
    if (evType == ControlEvent.PRESSED) { // Button
      if (obj == newGameButton) {
        if (DEBUG) System.out.println(newGameButton.getText());
        newGame();
      }
      else if (obj == giveupButton) {
        if (DEBUG) System.out.println(giveupButton.getText() + ": " + answer);
        alert(answer, "The Answer");
      }
      else if (obj == helpButton)
        displayText(CMDSTR,0);
      else if (obj == exampleButton)
        displayText(EXSTR,0);
      else if (obj == allowZeroCheck) {
        allowZero = allowZeroCheck.getChecked();
        if (DEBUG) System.out.println(
          allowZeroCheck.getText() + ": " + allowZero);
        newGame();
      }
      else if (obj == numDigitChoice) { // !!!b. List
        if (DEBUG) System.out.println("Digits: " + numDigitChoice.getSelected());
        numDigits = NUMDIGIT_MIN + numDigitChoice.getSelectedIndex();
        newGame();
      }
      else if (obj == resultButton) { // !!!b
        // find last non-empty field
        for (pos=numGuesses-1; pos>=0; pos--) {
          str = ((Edit) guesses.get(pos)).getText();
          if (str.length() > 0) {
            ((Label) results.get(pos)).setText(evalGuess(str));
            break;
          };
        };
      }
      else if (DEBUG) System.out.println("ControlEvent? " + ev); // unexpected
    }
    else if (evType == KeyEvent.KEY_PRESS) {
      int key = ((KeyEvent) ev).key;
      str = ((Edit) obj).getText();
      slen = str.length();
/* !!!b.
      if (obj == numDigitChoice) {
        if (str.length() == 1 &&
          key >= DIGITS.charAt(NUMDIGIT_MIN) &&
          key <= DIGITS.charAt(NUMDIGIT_MAX)) {
            numDigits = Convert.toInt(str);
            newGame();
        }
        else alert("#", "between " + NUMDIGIT_MIN + " and " + NUMDIGIT_MAX);
      }
      else
*/
      if ((key == IKeys.ENTER || key == IKeys.TAB || key == 9) &&
          (pos = guesses.find(obj)) >= 0) {
        if (DEBUG) System.out.println("Guess(" + pos + "): " + str);
        if (slen > 0) {
          if (str.charAt(slen-1) == key)
            ((Edit) obj).setText(str = str.substring(0,slen-1));
          ((Label) results.get(pos)).setText(evalGuess(str));
        };
        // doesn't release earlier focus?
        // setFocus((Edit) (guesses.get((pos+1 < numGuesses) ? pos+1 : 0)));
      };
    };
    //else if (DEBUG) System.out.println("Event? " + ev);
  }

  private void alert (String msg1, String msg2) {
    //?? Sound.beep();
    String[] args2 = {msg1, msg2};
    displayText(args2, numGuesses-1);
  }

  private void displayText(String[] strs, int start) {
    int len = (strs == null) ? numGuesses : strs.length / 2;
    if (numGuesses < start+len)
      len = numGuesses;
    for (int i = 0; i < len; i++) {
      ((Edit)  guesses.get(start+i)).setText((strs == null) ? "" : strs[i*2]);
      ((Label) results.get(start+i)).setText((strs == null) ? "#" + (i+1) : strs[i*2 + 1]);
    };
  }

  private void newGame() {
    displayText(null, 0);
    answer = "";	// new 'blank' answer
    int z0 = (allowZero) ? 0 : 1;
    int z9 = 9, rdig;

    for (int i = 0; i < numDigits; i++) {
      // generate new digit in range (~0|1 - ~9), non-duplicate
      do {
        rdig = z0 + rand.getRandom(z9-z0+1);
      }
      while (StringUtil.indexOf(answer, DIGITS.charAt(rdig), 0) >= 0);

      answer += DIGITS.substring(rdig,rdig+1); // add new digit

      // squeeze range to elim some dups
      if (rdig == z0)
        z0++;
      else if (rdig == z9)
        z9--;
      };
    if (DEBUG) System.out.println("answer: " + answer);
  }


  private String evalGuess(String guess) {
    if (guess.length() == 0)
	return "";

    int i, fermi = 0, pico = 0, z0 = (allowZero) ? 0 : 1;
    StringBuffer result = new StringBuffer();
    char ch;
    String dupMsg = (numDigits < 4) ? " duplicate; " : " dup; ";
    String invMsg = (numDigits < 4) ? " invalid; "   : " inv; ";
    if (guess.length() != numDigits) {  // incorrect length
	result.append(numDigits);
        result.append(" digits only");
    }
    else {
      // check valid, duplicate, guess digits
      for (i = 0; i < numDigits; i++) {
        ch = guess.charAt(i);
        if (StringUtil.indexOf(DIGITS, ch, z0) < 0) { // invalid digit?
          result.append(ch);
          result.append(invMsg);
        }
        else if (StringUtil.indexOf(guess, ch, i+1) > i) { // duplicate?  //i+1 < numDigits && ...
          result.append(ch);
          result.append(dupMsg);
        }
        else if (answer.charAt(i) == ch)
          fermi++;
        else if (StringUtil.indexOf(answer, ch, 0) >= 0)
          pico++;
      };
    };

  String res = result.toString(); // no StringBuffer.length
  if (res.length() > 0) {
    if (DEBUG) System.out.println("result: " + res);
    return res;
  };

  if (pico == 0 && fermi == 0)
      return "Bagels";

  for (i=0; i < fermi; i++)
    result.append("Fermi ");
  if (fermi == numDigits) {
    //?? Sound.whi();
    result.append('!');
  }
  else {
    for (i=0; i < pico; i++)
      result.append("Pico ");
  };

  if (DEBUG) System.out.println("result: " + result.toString());
  return result.toString();
  }
}
